# DO NOT EDIT! This file was auto-generated by crates/build/re_types_builder/src/codegen/python/mod.rs
# Based on "crates/store/re_types/definitions/rerun/blueprint/components/table_group_by.fbs".

# You can extend this class by creating a "TableGroupByExt" class in "table_group_by_ext.py".

from __future__ import annotations

from typing import Literal, Sequence, Union

import pyarrow as pa

from ..._baseclasses import (
    BaseBatch,
    BaseExtensionType,
    ComponentBatchMixin,
)

__all__ = ["TableGroupBy", "TableGroupByArrayLike", "TableGroupByBatch", "TableGroupByLike", "TableGroupByType"]


from enum import Enum


class TableGroupBy(Enum):
    """**Component**: Primary element by which to group by in a temporal data table."""

    Entity = 1
    """Group by entity."""

    Time = 2
    """Group by instance."""


TableGroupByLike = Union[TableGroupBy, Literal["entity", "time"]]
TableGroupByArrayLike = Union[TableGroupByLike, Sequence[TableGroupByLike]]


class TableGroupByType(BaseExtensionType):
    _TYPE_NAME: str = "rerun.blueprint.components.TableGroupBy"

    def __init__(self) -> None:
        pa.ExtensionType.__init__(
            self,
            pa.sparse_union([
                pa.field("_null_markers", pa.null(), nullable=True, metadata={}),
                pa.field("Entity", pa.null(), nullable=True, metadata={}),
                pa.field("Time", pa.null(), nullable=True, metadata={}),
            ]),
            self._TYPE_NAME,
        )


class TableGroupByBatch(BaseBatch[TableGroupByArrayLike], ComponentBatchMixin):
    _ARROW_TYPE = TableGroupByType()

    @staticmethod
    def _native_to_pa_array(data: TableGroupByArrayLike, data_type: pa.DataType) -> pa.Array:
        if isinstance(data, (TableGroupBy, int, str)):
            data = [data]

        types: list[int] = []

        for value in data:
            if value is None:
                types.append(0)
            elif isinstance(value, TableGroupBy):
                types.append(value.value)  # Actual enum value
            elif isinstance(value, int):
                types.append(value)  # By number
            elif isinstance(value, str):
                if hasattr(TableGroupBy, value):
                    types.append(TableGroupBy[value].value)  # fast path
                elif value.lower() == "entity":
                    types.append(TableGroupBy.Entity.value)
                elif value.lower() == "time":
                    types.append(TableGroupBy.Time.value)
                else:
                    raise ValueError(f"Unknown TableGroupBy kind: {value}")
            else:
                raise ValueError(f"Unknown TableGroupBy kind: {value}")

        buffers = [
            None,
            pa.array(types, type=pa.int8()).buffers()[1],
        ]
        children = (1 + 2) * [pa.nulls(len(data))]

        return pa.UnionArray.from_buffers(
            type=data_type,
            length=len(data),
            buffers=buffers,
            children=children,
        )
